// ChildFrame.cpp : implementation of the ChildFrame class
//

#include "stdafx.h"
#include "CvsConflictEditor.h"
#include "ChildFrame.h"
#include "ConflictEditorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ChildFrame

IMPLEMENT_DYNCREATE(ChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(ChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(ChildFrame)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ChildFrame construction/destruction

ChildFrame::ChildFrame()
{
	// TODO: add member initialization code here
	
}

ChildFrame::~ChildFrame()
{
}

BOOL ChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// ChildFrame diagnostics

#ifdef _DEBUG
void ChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void ChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// ChildFrame message handlers

BOOL ChildFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	// create a splitter with 1 row, 2 columns
	if (!m_splitter.CreateStatic(this, 1, 2, WS_CHILD | WS_VISIBLE | WS_HSCROLL) )
	{
		TRACE0("Failed to CreateStaticSplitter\n");
		return FALSE;
	}
	
	if (!m_splitter.CreateView(0, 0,
		RUNTIME_CLASS(ConflictEditorView), CSize(-1, 200), pContext))
	{
		TRACE0("Failed to create first pane\n");
		return FALSE;
	}
	
	// add the second splitter pane - an input view in column 1
	if (!m_splitter.CreateView(0, 1,
		RUNTIME_CLASS(ConflictEditorView), CSize(-1, 200), pContext))
	{
		TRACE0("Failed to create second pane\n");
		return FALSE;
	}

  ConflictEditorView *pTargetView = (ConflictEditorView *)m_splitter.GetPane(0,0);;
  ConflictEditorView *pMergedView = (ConflictEditorView *)m_splitter.GetPane(0,1);

  pTargetView->SetTargetView();
  pMergedView->SetMergedView();

  shareClientAreaBetweenViews();

  return TRUE;
}


int 
ChildFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	return 0;
}


void 
ChildFrame::ActivateFrame(int nCmdShow) 
{
  nCmdShow = SW_SHOWMAXIMIZED;
	
	CMDIChildWnd::ActivateFrame(nCmdShow);
}


void 
ChildFrame::OnSize(UINT nType, int cx, int cy) 
{
  CMDIChildWnd::OnSize(nType, cx, cy);

  if ( IsWindowVisible() )
    shareClientAreaBetweenViews();
}


void 
ChildFrame::shareClientAreaBetweenViews()
{
	CRect rc;
	GetClientRect( &rc );
	m_splitter.SetColumnInfo( 0, rc.Width()/2, 10);
	m_splitter.RecalcLayout();
}
