// //////////////////////////////////////////////////////////////////////////
// Header file ConflictMarginDrawer.h for class ConflictMarginDrawer
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/17
// //////////////////////////////////////////////////////////////////////////
#ifndef CONFLICTMARGINDRAWER_H
#define CONFLICTMARGINDRAWER_H

class ConflictTextBuffer;


/*! \class ConflictMarginDrawer
 * \brief This class draws into the margin to reprents a conflict block.
 */
class ConflictMarginDrawer
{
public:
  /*! Constructs a ConflictMarginDrawer object.
   */
  ConflictMarginDrawer();

  /*! Destructor.
   */
  virtual ~ConflictMarginDrawer();

  virtual void DrawMargin( CDC * pDc, 
                           const CRect &rect, 
                           int nLineIndex,
                           ConflictTextBuffer *pTextBuffer,
                           int nCurrentConflictIndex );

private:
  /// Prevents the use of the copy constructor.
  ConflictMarginDrawer( const ConflictMarginDrawer &copy );

  /// Prevents the use of the copy operator.
  void operator =( const ConflictMarginDrawer &copy );

  void drawInsideConflictBlockMark( CDC *pDc, 
                                    const CRect &rect, 
                                    COLORREF blockColor );

  void drawBeginConflictBlockMark( CDC *pDc, 
                                   const CRect &rect, 
                                   COLORREF blockColor );
  void drawEndConflictBlockMark( CDC *pDc, 
                                 const CRect &rect, 
                                 COLORREF blockColor );

  COLORREF conflictBlockColorFor( int nLineStatus );
  
  COLORREF conflictBlockColor();
  
  COLORREF selectedConflictBlockColor();
  
private:
  const int m_conflictBlockLimitWidth;
  const int m_conflictBlockLimitHeight;
  const int m_conflictBlockMarkWidth;
  const int m_conflictBlockRightMargin;
  const int m_conflictBlockLeftBorderOffset;
};



// Inlines methods for ConflictMarginDrawer:
// -----------------------------------------



#endif  // CONFLICTMARGINDRAWER_H
