// //////////////////////////////////////////////////////////////////////////
// Implementation file ConflictTextBuffer.cpp for class ConflictTextBuffer
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/15
// //////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "ConflictTextBuffer.h"
#include "ConflictTextBufferListener.h"
#include "ConflictList.h"

/* Note:
  - lineInConflictBlockStatus should use binary search.
 */


ConflictTextBuffer::ConflictTextBuffer( ConflictTextBufferListener *listener ) : 
    m_listener( listener ),
    m_bIsLoading( false ),
    m_pConflicts( new ConflictList() )
{
}


ConflictTextBuffer::~ConflictTextBuffer()
{
  delete m_pConflicts;
}


void 
ConflictTextBuffer::SetModified( BOOL bModified )
{
  m_listener->textBufferModified( this, bModified != FALSE );
}


void 
ConflictTextBuffer::lineInsertedAt( int nLineIndex )
{
  if ( m_bIsLoading )
    return;

  m_pConflicts->insertedLineAt( nLineIndex );
}


void 
ConflictTextBuffer::linesDeletedAt( int nLineIndex, 
                                    int nNumberOfLines )
{
  if ( m_bIsLoading  ||  nNumberOfLines < 0 )
    return;

  m_pConflicts->removedLinesAt( nLineIndex, nNumberOfLines );
}


ConflictList *
ConflictTextBuffer::conflicts()
{
  return m_pConflicts;
}


void 
ConflictTextBuffer::insertLoadedLine( std::string line )
{
  m_bIsLoading = true;
  InsertLine( line.c_str() );
  m_bIsLoading = false;
}
