// //////////////////////////////////////////////////////////////////////////
// Implementation file ConflictTextBufferBuilder.cpp for class ConflictTextBufferBuilder
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/17
// //////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "ConflictBlock.h"
#include "ConflictList.h"
#include "ConflictTextBuffer.h"
#include "ConflictTextBufferBuilder.h"


ConflictTextBufferBuilder::ConflictTextBufferBuilder( 
                               ConflictTextBuffer *pTextBuffer ) :
    m_pTextBuffer( pTextBuffer )
{
  pTextBuffer->InitNew( CRLF_STYLE_DOS, false );
}


ConflictTextBufferBuilder::~ConflictTextBufferBuilder()
{
}


void 
ConflictTextBufferBuilder::setEndOfLineDos()
{
  m_pTextBuffer->SetCRLFMode( CRLF_STYLE_DOS );
}


void 
ConflictTextBufferBuilder::setEndOfLineMac()
{
  m_pTextBuffer->SetCRLFMode( CRLF_STYLE_MAC );
}


void 
ConflictTextBufferBuilder::setEndOfLineUnix()
{
  m_pTextBuffer->SetCRLFMode( CRLF_STYLE_UNIX );
}


void 
ConflictTextBufferBuilder::appendLine( std::string line )
{
  m_pTextBuffer->insertLoadedLine( line.c_str() );
  if ( m_ptrConflictInBuilding.get() != NULL )
    m_ptrConflictInBuilding->addLine( line );
}


void 
ConflictTextBufferBuilder::beginConflictBlock()
{
  m_ptrConflictInBuilding = std::auto_ptr<ConflictBlock>( 
      new ConflictBlock( m_pTextBuffer->GetLineCount() ) );
}


void 
ConflictTextBufferBuilder::endConflictBlock()
{
  m_pTextBuffer->conflicts()->addConflict( m_ptrConflictInBuilding.release() );
  m_ptrConflictInBuilding = std::auto_ptr<ConflictBlock>();
}
