// //////////////////////////////////////////////////////////////////////////
// Header file ConflictTextBufferBuilder.h for class ConflictTextBufferBuilder
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/17
// //////////////////////////////////////////////////////////////////////////
#ifndef CONFLICTTEXTBUFFERBUILDER_H
#define CONFLICTTEXTBUFFERBUILDER_H

#include "ConflictTextBuilder.h"
#include <memory>
class ConflictTextBuffer;
class ConflictBlock;


/*! \class ConflictTextBufferBuilder
 * \brief This class represents a builder for ConflictTextBuffer.
 */
class ConflictTextBufferBuilder : public ConflictTextBuilder
{
public:
  /*! Constructs a ConflictTextBufferBuilder object.
   */
  ConflictTextBufferBuilder( ConflictTextBuffer *pTextBuffer );

  /*! Destructor.
   */
  virtual ~ConflictTextBufferBuilder();

  void setEndOfLineDos();
  void setEndOfLineMac();
  void setEndOfLineUnix();
  void appendLine( std::string line );
  void beginConflictBlock();
  void endConflictBlock();

private:
  /// Prevents the use of the copy constructor.
  ConflictTextBufferBuilder( const ConflictTextBufferBuilder &copy );

  /// Prevents the use of the copy operator.
  void operator =( const ConflictTextBufferBuilder &copy );

private:
  ConflictTextBuffer *m_pTextBuffer;
  int m_nConflictBlockStartLineNumber;
  std::auto_ptr<ConflictBlock> m_ptrConflictInBuilding;
};



// Inlines methods for ConflictTextBufferBuilder:
// ----------------------------------------------



#endif  // CONFLICTTEXTBUFFERBUILDER_H
