// //////////////////////////////////////////////////////////////////////////
// Implementation file DosLineReader.cpp for class DosLineReader
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/16
// //////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "DosLineReader.h"
#include "ConflictTextBuilder.h"


DosLineReader::DosLineReader( CFile *pFile ) : 
    LineReader( pFile )
{
}


DosLineReader::~DosLineReader()
{
}


void 
DosLineReader::setEndOfLineType( ConflictTextBuilder *pBuffer )
{
  pBuffer->setEndOfLineDos();
}


std::string 
DosLineReader::readLine()
{
  std::string line;
  char nextChar;
  try
  {
    m_archive >> nextChar;
    while ( nextChar != 13 )
    {
      line += nextChar;
      m_archive >> nextChar;
    }

    m_archive >> nextChar;    // skip 10
  }
  catch ( CArchiveException *e )
  {
    e->Delete();
    if ( line.empty() )
      throw NoMoreLine();
  }
  return line;
}
