// //////////////////////////////////////////////////////////////////////////
// Implementation pFile LineReader.cpp for class LineReader
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/16
// //////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "LineReader.h"
#include "DosLineReader.h"
#include "UnixLineReader.h"
#include "MacLineReader.h"


LineReader::LineReader( CFile *pFile ) :
    m_file( pFile->GetFilePath(), 
            CFile::modeRead | CFile::shareDenyNone ),
    m_archive( &m_file, CArchive::load )
{
}


LineReader::~LineReader()
{
}


LineReader *
LineReader::makeLineReaderFor( CFile *pFile )
{
  CArchive archive( pFile, CArchive::load );

  BYTE byte;
  bool guessingDosOrMac = false;
  try
  {
    do
    {
      archive >> byte;
    }
    while ( byte != 10  &&  byte != 13 );

    if ( byte == 10 )
      return new UnixLineReader( pFile );

    guessingDosOrMac = true;
    archive >> byte;
    if ( byte != 10 )
      return new MacLineReader( pFile );
  }
  catch ( CArchiveException *e )
  {
    e->Delete();
    if ( guessingDosOrMac )
      return new MacLineReader( pFile );
  }

  return new DosLineReader( pFile );
}
