// //////////////////////////////////////////////////////////////////////////
// Implementation file MacLineReader.cpp for class MacLineReader
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/16
// //////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "MacLineReader.h"
#include "ConflictTextBuilder.h"


MacLineReader::MacLineReader( CFile *pFile ) : 
    LineReader( pFile )
{
}


MacLineReader::~MacLineReader()
{
}


void 
MacLineReader::setEndOfLineType( ConflictTextBuilder *pBuffer )
{
  pBuffer->setEndOfLineMac();
}


std::string 
MacLineReader::readLine()
{
  std::string line;
  char nextChar;
  try
  {
    m_archive >> nextChar;
    while ( nextChar != 13 )
    {
      line += nextChar;
      m_archive >> nextChar;
    }
  }
  catch ( CArchiveException *e )
  {
    e->Delete();
    if ( line.empty() )
      throw NoMoreLine();
  }
  return line;
}
