// //////////////////////////////////////////////////////////////////////////
// Header file MacLineReader.h for class MacLineReader
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/16
// //////////////////////////////////////////////////////////////////////////
#ifndef MACLINEREADER_H
#define MACLINEREADER_H

#include "LineReader.h"


/*! \class MacLineReader
 * \brief This class represents for MAC file
 */
class MacLineReader : public LineReader
{
public:
  /*! Constructs a MacLineReader object.
   */
  MacLineReader( CFile *pFile );

  /*! Destructor.
   */
  virtual ~MacLineReader();

  virtual void setEndOfLineType( ConflictTextBuilder *pBuffer );
  virtual std::string readLine();

private:
  /// Prevents the use of the copy constructor.
  MacLineReader( const MacLineReader &copy );

  /// Prevents the use of the copy operator.
  void operator =( const MacLineReader &copy );

private:
};



// Inlines methods for MacLineReader:
// ----------------------------------



#endif  // MACLINEREADER_H
