// //////////////////////////////////////////////////////////////////////////
// Implementation file MultiFileDropList.cpp for class MultiFileDropList
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/18
// //////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MultiFileDropList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


MultiFileDropList::MultiFileDropList(HDROP hDrop)
{
  UINT nFileCount = ::DragQueryFile( hDrop, 0xffffffff, NULL, 0 );
  if ( nFileCount < 0 )
    return;

  for ( int nFileIndex = 0; nFileIndex < nFileCount; ++nFileIndex )
  {
    CString fileName( dropSourceFileNameAt( hDrop, nFileIndex ) );
    m_droppedFiles.push_back( fileName );
  }
}


MultiFileDropList::~MultiFileDropList()
{
}


CString 
MultiFileDropList::dropSourceFileNameAt( HDROP hDrop, 
                                         int nFileIndex )
{
  CString fileName;
  UINT nBufferSize = ::DragQueryFile( hDrop, nFileIndex, NULL, 0 ) + 1;
  ::DragQueryFile( hDrop, 
                   nFileIndex, 
                   fileName.GetBufferSetLength( nBufferSize ), 
                   nBufferSize );
  fileName.ReleaseBuffer();
  return fileName;
}


void 
MultiFileDropList::openDocuments()
{
  CWinApp *pApplication = AfxGetApp();
  if ( !pApplication )
    return;

  for ( DroppedFiles::iterator it = m_droppedFiles.begin(); 
        it != m_droppedFiles.end(); 
        ++it )
  {
    CString fileName( *it );
    pApplication->OpenDocumentFile( fileName );
  }
}
