// //////////////////////////////////////////////////////////////////////////
// Header file UnixLineReader.h for class UnixLineReader
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/06/16
// //////////////////////////////////////////////////////////////////////////
#ifndef UNIXLINEREADER_H
#define UNIXLINEREADER_H

#include "LineReader.h"


/*! \class UnixLineReader
 * \brief This class represents a line reader for UNIX file.
 */
class UnixLineReader : public LineReader
{
public:
  /*! Constructs a UnixLineReader object.
   */
  UnixLineReader( CFile *pFile );

  /*! Destructor.
   */
  virtual ~UnixLineReader();

  virtual void setEndOfLineType( ConflictTextBuilder *pBuffer );
  virtual std::string readLine();

private:
  /// Prevents the use of the copy constructor.
  UnixLineReader( const UnixLineReader &copy );

  /// Prevents the use of the copy operator.
  void operator =( const UnixLineReader &copy );

private:
};



// Inlines methods for UnixLineReader:
// -----------------------------------



#endif  // UNIXLINEREADER_H
